package com.fossgalaxy.games.tbs.metrics.parameters;

import com.fossgalaxy.games.tbs.parameters.GameSettings;

public class EntityCost extends Parameter {
	private String entity;
	private String prop;
	
	public EntityCost(String string, String string2, int i, int j, int k) {
		super(i, j, k);
		this.entity = string;
		this.prop = string2;
	}

	@Override
	public void update(GameSettings settings, int val, boolean isIndex) {
		int value = val;
		if (isIndex) {
			value = getValue(val);
		}
		settings.setEntityCost(entity, prop, value);
	}

	@Override
	public String getPrettyName() {
		return String.format("cost(%s):%s", entity, prop);
	}

	@Override
	public Integer extractValue(GameSettings settings) {
		return settings.getEntityType(entity).getCosts().getOrDefault(prop, 0);
	}
}
