package com.fossgalaxy.games.tbs.metrics.parameters;

import com.fossgalaxy.games.tbs.parameters.GameSettings;

public class EntityProp extends Parameter {
	
	private String entity;
	private String prop;
	
	public EntityProp(String string, String string2, int i, int j, int k) {
		super(i, j, k);
		this.entity = string;
		this.prop = string2;
	}
	
	public EntityProp(String string, String string2, int i, int j) {
		this(string, string2, i, j, 1);
	}

	@Override
	public void update(GameSettings settings, int val, boolean isIndex) {
		int value = val;
		if (isIndex) {
			value = getValue(val);
		}

		settings.setEntityProp(entity, prop, value);
	}

	@Override
	public String getPrettyName() {
		return String.format("%s:%s", entity, prop);
	}

	public Integer extractValue(GameSettings settings){
		return settings.getEntityType(entity).getProperty(prop);
	}

	public String toString() {
		return String.format("%s's %s between %d and %d in steps of %d", entity, prop, getMin(), getMax(), getStep());
	}
	
}
