package com.fossgalaxy.games.tbs.metrics.parameters;

import com.fossgalaxy.games.tbs.parameters.GameSettings;

import io.jenetics.IntegerChromosome;

public abstract class Parameter {
	private int min;
	private int max;
	private int step;
	
	public Parameter(int min, int max, int step) {
		this.min = min;
		this.max = max;
		this.step = step;
	}
	
	public Parameter(int min, int max) {
		this(min, max, 1);
	}

	public int getValue(int index){
		return min + (index*step);
	}

	private int[] getValue() {
		
		int[] values = new  int[(max - min) / step];
		for (int i=0; i<values.length; i++ ) {
			values[i] = min + (step*i);
		}
		
		return values;
	}

	public void update(GameSettings settings, int i){
		update(settings, i, true);
	}

	public abstract void update(GameSettings settings, int val, boolean isIndex);

	public int getMin() {
		return min;
	}

	public int getMax() {
		return max;
	}

	public int getStep() {
		return step;
	}

	public abstract String getPrettyName();

    public abstract Integer extractValue(GameSettings settings);
}
