package com.fossgalaxy.games.tbs.metrics.parameters;

import com.fossgalaxy.games.tbs.parameters.GameSettings;

public class TurnLimit extends Parameter {
    public TurnLimit(int min, int max, int step) {
        super(min, max, step);
    }

    @Override
    public void update(GameSettings settings, int i) {
        settings.setTurnLimit(i);
    }

    @Override
    public void update(GameSettings settings, int val, boolean isIndex) {
        int value = val;
        if (isIndex) {
            value = getValue(val);
        }

        settings.setTurnLimit(value);
    }

    @Override
    public String getPrettyName() {
        return "turnLimit";
    }

    @Override
    public Integer extractValue(GameSettings settings) {
        return settings.getTurnLimit();
    }
}
