package com.fossgalaxy.games.tbs.order;

import com.fossgalaxy.games.tbs.GameState;
import com.fossgalaxy.games.tbs.entity.Entity;

import java.util.Map;

public class SellOrder implements Order {

    private final double regen;

    public SellOrder(double regen) {
        this.regen = regen;
    }

    @Override
    public void doOrder(Entity host, GameState state) {
        for(Map.Entry<String, Integer> entry : host.getType().getCosts().entrySet()){
            state.addResource(host.getOwner(), entry.getKey(), (int)(entry.getValue() * regen * host.getHealthFrac()));
        }

        host.setHealth(0);
        state.removeEntity(host);
    }
}
